/* FILE: all.dsp                Copyright (c), Symmetric Research, 1992
 *
 * This file lists many of the DSP32C instructions for testing the
 * DSPASM assembler.  While the list is not complete, it does represent
 * much of the instruction set.
 *
 * The encoding of the instructions can be checked by assembling with
 * the DSPASM /l option, and comparing the listing with the output of
 * the AT&T assembler.
 *
 * This file is not meant to be executed, only for testing encoding.
 *
 *
 */

constant

          OPCODE = 0x01234560, N = 7;


main {

      register i = r1, j = r2, k = r3;


        /* CAU arithemetic. */

        i = j + k;
        i = j - k;
        i = j & k;
        i = j | k;
        i = j ^ k;
        i = j # k;
        i = j &~ k;

        i = pc + 3;
        i = .;

        i - j;
        i - 3;

        i & j;
        i & 3;

        i = i + N;
        i = i + N;
        i = i & N;
        i = i | N;
        i = i ^ N;
        i = i # N;
        i = i &~ N;

        i = j * 2;
        i = j * 2;

        i = j * 4;
        i = j / 4;

        i = j >> 3;
        i = j >>> 3;
        i = j <<< 3;

        i = j * 8;

        i =  j;
        i = -j;


        /* CAU arithemetic, dyadic forms. */

        i += j;
        i -= j;
        i &= j;
        i |= j;
        i ^= j;
        i #= j;
        i &~= j;

        i += N;
        i -= N;
        i &= N;
        i |= N;
        i ^= N;
        i #= N;
        i &~= N;

        i *= 2;
        i /= 2;

        i *= 4;
        i /= 4;

        i >>= 3;
        i >>>= 3;
        i <<<= 3;

        i *= 8;



        /* IO register instructions. */

        pdr  = r1;
        pir  = r1;
        pcw  = r1;

        obuf = r1;
        piop = r1;
        pdr2 = r1;

        ioc  = 0x0080;
        dauc = 0x0010;

        r1 = 0x1000;
        r1 = *0x1000;
        r1 = *r2;
        r1 = *r2.w;
        r1 = *r2.b;

        r1 = pdr;
        r1 = pir;
        r1 = pcw;

        r1 = ibuf;
        r1 = piop;
        r1 = pdr2;

        *r1 = r2;
        *r1 = r2.w;
        *r1 = r2.b;



        /* Emit hex opcodes directly to the .dso. */

        emit( OPCODE, OPCODE+3, OPCODE|N );



        /* DAU floating point arithmetic. */

        *r1 = a0 = - a2 + *r2 * *r3;

        a0 = a1 - (*r2 = *r3++) * *r4;

        *r1 = a0 = - *r2 + a1 * *r3;

        *r1 = a3 = - *r1 * *r2;

        a1 = (*r1 = *r4) * *r5;

        *r1 = a3 = *r1 + *r2;

        *r3 = a1 = - *r4;

        a0 = - (*r1 = a2) + *r3;


        *r1 = a0 = ic( *r3);
        *r1 = a0 = oc( *r3);
        *r1 = a0 = float( *r3);
        *r1 = a0 = float24( *r3);
        *r1 = a0 = int( *r3);
        *r1 = a0 = int24( *r3);
        *r1 = a0 = round( *r3);
        *r1 = a0 = ifalt( *r3);
        *r1 = a0 = ifaeq( *r3);
        *r1 = a0 = ifagt( *r3);
        *r1 = a0 = dsp( *r3);
        *r1 = a0 = ieee( *r3);
        *r1 = a0 = seed( *r3);



        /* Conditional constructs. */

        if ( pl ) { r1 = r2; }          /* ca conditions        */
        if ( mi ) { r1 = r2; }
        if ( ne ) { r1 = r2; }
        if ( eq ) { r1 = r2; }
        if ( vc ) { r1 = r2; }
        if ( vs ) { r1 = r2; }
        if ( cc ) { r1 = r2; }
        if ( cs ) { r1 = r2; }
        if ( ge ) { r1 = r2; }
        if ( lt ) { r1 = r2; }
        if ( gt ) { r1 = r2; }
        if ( le ) { r1 = r2; }
        if ( hi ) { r1 = r2; }
        if ( ls ) { r1 = r2; }

        if ( ane ) { r1 = r2; }         /* da conditions        */
        if ( aeq ) { r1 = r2; }
        if ( age ) { r1 = r2; }
        if ( alt ) { r1 = r2; }
        if ( avc ) { r1 = r2; }
        if ( avs ) { r1 = r2; }
        if ( auc ) { r1 = r2; }
        if ( aus ) { r1 = r2; }
        if ( agt ) { r1 = r2; }
        if ( ale ) { r1 = r2; }

        if ( ibe ) { r1 = r2; }         /* io conditions        */
        if ( ibf ) { r1 = r2; }
        if ( obf ) { r1 = r2; }
        if ( obe ) { r1 = r2; }
        if ( pde ) { r1 = r2; }
        if ( pdf ) { r1 = r2; }
        if ( pie ) { r1 = r2; }
        if ( pif ) { r1 = r2; }
        if ( syc ) { r1 = r2; }
        if ( sys ) { r1 = r2; }
        if ( fbc ) { r1 = r2; }
        if ( fbs ) { r1 = r2; }
        if ( ireq1_hi ) { r1 = r2; }
        if ( ireq1_lo ) { r1 = r2; }
        if ( ireq2_hi ) { r1 = r2; }
        if ( ireq2_lo ) { r1 = r2; }


        if ( i < j ) { i = j; }

        while ( i-- > 0 ) { j *= 2; }

        for ( i = 0 ; i < 50 ; i++ ) { j /= 2; }




}


/* Hex constants and expressions. */

constant

        N00 =      12345678,
        N01 =      12345678l,
        N02 =      12345678L,
        N03 =    0x12345678,
        N04 =    0X12345678,
        N05 =    0x12345678L,

        N06 =  -   12345678,
        N07 =  -   12345678l,
        N08 =  -   12345678L,
        N09 =  - 0x12345678,
        N10 =  - 0X12345678,
        N11 =  - 0x12345678L,

        N12 =  1 + 2*3,
        N13 =  (1+3)*3,
        N14 =  5*N00 + 2|(N01+N02),

        ;
