/* FILE: convert.s              Copyright (c), Symmetric Research, 1991
 *
 * This AT&T assembler program converts DSP32C floats to IEEE format, using
 * the DAU special ieee instruction.
 *
 * To run the program, the executable convert.out should be downloaded by
 * hand in DSPMON and run.  Check memory before and after execution to see
 * the correct results.
 *
 *
 * NOTE:
 *
 * When in DSPMON, you can use the df and di commands to display DSP32C
 * or IEEE floats respectively.  Make sure to use the proper commands to
 * correctly see your results.
 *
 *
 */

.rsect  ".main"


/* main()
 *
 * Convert an array from DSP32C floats to IEEE floats.
 *
 * In C pseudo code:
 *
 *      s = dsp_array; d = ieee_array;
 *
 *      while ( n-- )
 *              *d++ = a0 = ieee( *s++);
 *
 *
 */

main:
        r1e = dspf_array;       /* r1 -> array of DSP32C floats         */
        r2e = ieee_array;       /* r2 -> array of IEEE floats           */

        do 0,7                  /* convert each array entry             */

                *r2++ = a0 = ieee( *r1++);


wait:   goto wait               /* wait for the PC                      */



dspf_array:                     /* input array                          */

        float   1.0, 2.0, 3.0, 4.0, -1.0, -2.1, -3.2, -4.3

ieee_array:                     /* converted ieee array                 */

        float   0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
