/* FILE: select.c               Copyright (c), Symmetric Research, 1992-2000
 *
 * This program selects a cpu on the DSPMUL multiple cpu board.  You may want
 * to run it after powering up to make sure a valid cpu is selected.
 *
 *
 *
 *
 *
 */

#include <stdio.h>
#include <stdlib.h>

#include "dspio.h"





/* DOS USAGE MESSAGE AND ERRORS:
 *
 *
 *
 */

char *DOS_UsageMsg[] = {

   "USAGE: select n                                                  \n",
   "                                                                 \n",
   "    n = cpu selection on DSPMUL multiple cpu boards (0,1,2,3)    \n",

   NULL,

   };


void DOS_Usage( void) {
        
        int i;

        /* Print out the DOS command line usage message and quit. */

        for ( i = 0 ; DOS_UsageMsg[i] ; i++ )

                printf( DOS_UsageMsg[i]);
        
        exit( 1);

}       
void DOS_Error( char *msg) {

        /* Print out a DOS command line error and quit. */

        printf( "ERROR: %s\n", msg);
        
        exit( 1);

}



/* MAIN:
 *
 * Select a cpu to use on the DSPMUL board.
 *
 * Note that once the cpu selection register is poked, the same cpu will be
 * connected to the ISA bus until the selection register is programmed with
 * a different cpu.
 *
 *
 *
 */

int main( int argc, char *argv[]) {

        int n;


        /* Check the number of command line arguments. */

        if ( argc != 2 )

                DOS_Usage();


        /* Get the cpu to select. */

        if ( sscanf( argv[1], "%d", &n) != 1 || n < 0 || 3 < n )

                DOS_Error( "must specify cpu 0,1,2, or 3");



        /* Make the DSPMUL cpu selection. */

        DSP32C_SelectCpu( n);


        exit( 0 );
}
